//+------------------------------------------------------------------+
//|                                                ATR_SL_CHANEL.mq4 |
//|                                                          Kalenzo |
//|                                                  simone@konto.pl |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "simone@konto.pl"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green
double up[],dn[];
extern int ATR_FACTOR = 3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    SetIndexStyle(0,DRAW_LINE,0,1);
    SetIndexBuffer(0,up);
    SetIndexStyle(1,DRAW_LINE,0,1);
    SetIndexBuffer(1,dn);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//---- 
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=0;i<limit;i++)
   {
      dn[i] = High[Highest(Symbol(),0,MODE_HIGH,10,i)] - (ATR_FACTOR*iATR(Symbol(),0,10,i));
      up[i] = Low[Lowest(Symbol(),0,MODE_LOW,10,i)] + (ATR_FACTOR*iATR(Symbol(),0,10,i));
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+